Index: branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 3864)
+++ branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 3895)
@@ -914,5 +1304,6 @@
       !! Local variables
       INTEGER ::  ji, jj, jk                   ! dummy loop indices
-      INTEGER :: ijie,ijis,ijje,ijjs,jii,jjj
+      INTEGER ::  ijie, ijje, ii, ij
+      REAL(wp) :: ze3crs  
       !!----------------------------------------------------------------  
       ! Initialize
@@ -923,19 +1314,23 @@
          
             DO jk = 1 , jpk
-              
-               DO ji = 2, nlei_crs        ! ji = 1 et jpi_crs definit par cyclique est-ouest et pivot T
-                   ijie = mie_crs(ji)
-                   ijis = mis_crs(ji)
-
-                   DO jj =  njstart, njend  ! jj = jpj_crs definit par pivot T 
-                      ijje = mje_crs(jj) 
-                      ijjs = mjs_crs(jj)  
-                      
-                      DO jii = ijis, ijie
-                         DO jjj = ijjs, ijje
-                            p_e3_crs(ji,jj,jk) = max( p_e3_crs(ji,jj,jk), p_e3(jii,jjj,jk) * p_mask(jii,jjj,jk)  )
-                         ENDDO
-                      ENDDO
-                   ENDDO
+               DO ji = nistr, niend, nn_factx
+                  DO jj = njstr, njend, nn_facty
+                     ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                     ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                     ijje = mje_crs(ij)
+                     ijie = mie_crs(ii)
+                     !  
+                     ze3crs = MAX( p_e3(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk),  &
+                        &          p_e3(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk),  &
+                        &          p_e3(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk),  &
+                        &          p_e3(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk),  &
+                        &          p_e3(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk),  &
+                        &          p_e3(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk),  &
+                        &          p_e3(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk),  &
+                        &          p_e3(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk),  &
+                        &          p_e3(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk) )
+                    
+                     p_e3_crs(ii,ij,jk) = ze3crs
+                  ENDDO
                ENDDO
             ENDDO
@@ -944,159 +1339,200 @@
          
             DO jk = 2 , jpk
-            
-                                          ! ji = 1 et jpi_crs definit par cyclique est-ouest et pivot T
-               DO ji = 2, nlei_crs
-                   ijie = mie_crs(ji)
-                   ijis = mis_crs(ji)
-
-                   DO jj = njstart, njend ! jj = jpj_crs definit par pivot T 
-                      ijje = mje_crs(jj) 
-                      ijjs = mjs_crs(jj)  
-                   
-                      DO jii = ijis, ijie
-                         DO jjj = ijjs, ijje
-                            p_e3_crs(ji,jj,jk) = max( p_e3_crs(ji,jj,jk), p_e3(jii,jjj,jk) * p_mask(jii,jjj,jk-1)  )
-                         ENDDO
-                      ENDDO
-                   ENDDO
-               ENDDO
-            ENDDO
-             
-            jk = 1                                           ! cas particulier car zpmask(jii,jjj,0) n'existe pas      
-          
-            DO ji = 2, nlei_crs
-               ijie = mie_crs(ji)
-               ijis = mis_crs(ji)
-
-               DO jj = njstart, njend            
-                  ijje = mje_crs(jj) 
-                  ijjs = mjs_crs(jj)  
-                   
-                  DO jii = ijis, ijie
-                     DO jjj = ijjs, ijje
-                        p_e3_crs(ji,jj,jk) = max( p_e3_crs(ji,jj,jk), p_e3(jii,jjj,jk) * p_mask(jii,jjj,jk)  )
-                     ENDDO
+               DO ji = nistr, niend, nn_factx
+                  DO jj = njstr, njend, nn_facty
+                     ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                     ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                     ijje = mje_crs(ij)
+                     ijie = mie_crs(ii)
+                     !  
+                     ze3crs = MAX( p_e3(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk-1),  &
+                        &          p_e3(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk-1),  &
+                        &          p_e3(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk-1),  &
+                        &          p_e3(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk-1),  &
+                        &          p_e3(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk-1),  &
+                        &          p_e3(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk-1),  &
+                        &          p_e3(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk-1),  &
+                        &          p_e3(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk-1),  &
+                        &          p_e3(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk-1) )
+                    
+                     p_e3_crs(ii,ij,jk) = ze3crs
                   ENDDO
                ENDDO
-            ENDDO  
+            ENDDO
+             
+            DO ji = nistr, niend, nn_factx
+               DO jj = njstr, njend, nn_facty
+                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                  ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                  ijje = mje_crs(ij)
+                  ijie = mie_crs(ii)
+                  !  
+                  ze3crs = MAX( p_e3(ji  ,jj  ,1) * p_mask(ji  ,jj  ,1),  &
+                     &          p_e3(ji+1,jj  ,1) * p_mask(ji+1,jj  ,1),  &
+                     &          p_e3(ji+2,jj  ,1) * p_mask(ji+2,jj  ,1),  &
+                     &          p_e3(ji  ,jj+1,1) * p_mask(ji  ,jj+1,1),  &
+                     &          p_e3(ji+1,jj+1,1) * p_mask(ji+1,jj+1,1),  &
+                     &          p_e3(ji+2,jj+1,1) * p_mask(ji+2,jj+1,1),  &
+                     &          p_e3(ji  ,jj+2,1) * p_mask(ji  ,jj+2,1),  &
+                     &          p_e3(ji+1,jj+2,1) * p_mask(ji+1,jj+2,1),  &
+                     &          p_e3(ji+2,jj+2,1) * p_mask(ji+2,jj+2,1) )
+                 
+                  p_e3_crs(ii,ij,1) = ze3crs
+               ENDDO
+            ENDDO
             
          END SELECT 
-                  
-         CALL crs_lbc_lnk( p_e3_crs(:,:,:),cd_type, 1.0, pval=1.0 )  
-     
-         WRITE(numout,*) 'crs_e3_max : end of subroutine '
- 
-
+         !              
+         CALL crs_lbc_lnk( p_e3_crs, cd_type, 1.0, pval=1.0 )  
+         !              
    END SUBROUTINE crs_dom_e3_max
 
-
-   SUBROUTINE crs_dom_sfc( p_e1, p_e2, p_e3, cd_type, p_mask, p_surf_crs, p_surf_crs_msk )
+   SUBROUTINE crs_dom_sfc( p_mask, cd_type, p_surf_crs, p_surf_crs_msk,  p_e1, p_e2, p_e3 )
 
       !!  Arguments
       CHARACTER(len=1),                 INTENT(in) :: cd_type      ! grid type T, W ( U, V, F)
       REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) :: p_mask       ! Parent grid T mask
-      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(in) :: p_e1, p_e2         ! 3D tracer T or W on parent grid
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in) :: p_e3         ! 3D tracer T or W on parent grid
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(inout):: p_surf_crs ! Coarse grid box east or north face quantity 
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(inout):: p_surf_crs_msk ! Coarse grid box east or north face quantity 
+      REAL(wp), DIMENSION(jpi,jpj)    , INTENT(in), OPTIONAL :: p_e1, p_e2         ! 3D tracer T or W on parent grid
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in), OPTIONAL :: p_e3         ! 3D tracer T or W on parent grid
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(out):: p_surf_crs ! Coarse grid box east or north face quantity 
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(out):: p_surf_crs_msk ! Coarse grid box east or north face quantity 
 
       !! Local variables
-      INTEGER  ::  ji, jj, jk                   ! dummy loop indices
-      INTEGER  :: ijie,ijis,ijje,ijjs,ijpk,jii,jjj
-      REAL(wp) :: zsfc
+      INTEGER  :: ji, jj, jk                   ! dummy loop indices
+      INTEGER  :: ijie, ijje, ii, ij
+      REAL(wp), DIMENSION(:,:)  , POINTER :: zsurf   
+      REAL(wp), DIMENSION(:,:,:), POINTER :: zsurf3d   
+      REAL(wp) :: zsfcrs, zsfcrs_msk
       !!----------------------------------------------------------------  
       ! Initialize
 
-      p_surf_crs    (:,:,:) = 0._wp
-      p_surf_crs_msk(:,:,:) = 0._wp
+
       !
       SELECT CASE ( cd_type )
       
          CASE ('W')
-
-            DO jk = 2 , jpk
-                DO ji = 2, nlei_crs
-                   ijie = mie_crs(ji)
-                   ijis = mis_crs(ji)
-                   DO jj = njstart, njend
-                      ijje = mje_crs(jj) 
-                      ijjs = mjs_crs(jj)
-                      DO jii = ijis, ijie
-                         DO jjj = ijjs, ijje
-                            zsfc = p_e1(jii,jjj) * p_e2(jii,jjj)
-                            p_surf_crs(ji,jj,jk)     = p_surf_crs(ji,jj,jk) + zsfc
-                            p_surf_crs_msk(ji,jj,jk) = p_surf_crs_msk(ji,jj,jk) + zsfc * p_mask(jii,jjj,jk-1)               
-                         ENDDO
-                      ENDDO
-                      IF( njstart == 1 ) p_surf_crs(ji,jj,jk) = p_surf_crs(ji,jj,jk) * nn_facty
-                   ENDDO                  
+      
+           CALL wrk_alloc( jpi, jpj, zsurf )
+           zsurf(:,:) =  p_e1(:,:) * p_e2(:,:)
+        
+            DO ji = nistr, niend, nn_factx
+               DO jj   = njstr, njend, nn_facty
+                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                  ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                  ijje = mje_crs(ij)
+                  ijie = mie_crs(ii)
+                  !
+                  zsfcrs     =  zsurf(ji,jj  ) + zsurf(ji+1,jj  ) + zsurf(ji+2,jj  )  &
+                    &         + zsurf(ji,jj+1) + zsurf(ji+1,jj+1) + zsurf(ji+2,jj+1)  &
+                    &         + zsurf(ji,jj+2) + zsurf(ji+1,jj+2) + zsurf(ji+2,jj+2)  
+                  !
+                  zsfcrs_msk =  zsurf(ji  ,jj  ) * p_mask(ji  ,jj  ,1)  &
+                    &         + zsurf(ji+1,jj  ) * p_mask(ji+1,jj  ,1)  &
+                    &         + zsurf(ji+2,jj  ) * p_mask(ji+2,jj  ,1)  &
+                    &         + zsurf(ji  ,jj+1) * p_mask(ji  ,jj+1,1)  &
+                    &         + zsurf(ji+1,jj+1) * p_mask(ji+1,jj+1,1)  &
+                    &         + zsurf(ji+2,jj+1) * p_mask(ji+2,jj+1,1)  &
+                    &         + zsurf(ji  ,jj+2) * p_mask(ji  ,jj+2,1)  &
+                    &         + zsurf(ji+1,jj+2) * p_mask(ji+1,jj+2,1)  &
+                    &         + zsurf(ji+2,jj+2) * p_mask(ji+2,jj+2,1)
+                  !
+                  p_surf_crs    (ii,ij,1) = zsfcrs
+                  p_surf_crs_msk(ii,ij,1) = zsfcrs_msk
+                  !
                ENDDO
             ENDDO
+            DO jk = 2, jpk
+               !
+               p_surf_crs(:,:,jk) = p_surf_crs(:,:,1)
+               !
+               DO ji = nistr, niend, nn_factx
+                  DO jj   = njstr, njend, nn_facty
+                     ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                     ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                     ijje = mje_crs(ij)
+                     ijie = mie_crs(ii)
+                     !
+                     zsfcrs_msk =  zsurf(ji  ,jj  ) * p_mask(ji  ,jj  ,jk-1)  &
+                       &         + zsurf(ji+1,jj  ) * p_mask(ji+1,jj  ,jk-1)  &
+                       &         + zsurf(ji+2,jj  ) * p_mask(ji+2,jj  ,jk-1)  &
+                       &         + zsurf(ji  ,jj+1) * p_mask(ji  ,jj+1,jk-1)  &
+                       &         + zsurf(ji+1,jj+1) * p_mask(ji+1,jj+1,jk-1)  &
+                       &         + zsurf(ji+2,jj+1) * p_mask(ji+2,jj+1,jk-1)  &
+                       &         + zsurf(ji  ,jj+2) * p_mask(ji  ,jj+2,jk-1)  &
+                       &         + zsurf(ji+1,jj+2) * p_mask(ji+1,jj+2,jk-1)  &
+                       &         + zsurf(ji+2,jj+2) * p_mask(ji+2,jj+2,jk-1)
+                       !
+                       p_surf_crs_msk(ii,ij,jk) = zsfcrs_msk
+                       !
+                   ENDDO
+                ENDDO
+            ENDDO
                         
-            ! surface   ; ji = 1 et jpi_crs definit par cyclique est-ouest et pivot T
-            DO ji = 2, nlei_crs
-               ijie = mie_crs(ji)
-               ijis = mis_crs(ji)
-               DO jj = njstart, njend                           
-                  ijje = mje_crs(jj) 
-                  ijjs = mjs_crs(jj)
-                  DO jii = ijis, ijie 
-                     DO jjj = ijjs, ijje
-                        zsfc = p_e1(jii,jjj) * p_e2(jii,jjj)
-                        p_surf_crs(ji,jj,1)     = p_surf_crs(ji,jj,1) + zsfc
-                        p_surf_crs_msk(ji,jj,1) = p_surf_crs_msk(ji,jj,1) * zsfc * p_mask(jii,jjj,1)               
-                     ENDDO  
-                  ENDDO
-                  IF( njstart == 1 ) p_surf_crs(ji,jj,1) = p_surf_crs(ji,jj,1) * nn_facty               
-               ENDDO
-            ENDDO
+            CALL wrk_dealloc( jpi, jpj, zsurf )
+          
+         CASE( 'V' )
+           
+           CALL wrk_alloc( jpi, jpj, jpk, zsurf3d )
+           DO jk = 1, jpk
+              zsurf3d(:,:,jk) =  p_e1(:,:) * p_e3(:,:,jk)
+           ENDDO
+         
+           DO jk = 1, jpk
+              DO ji = nistr, niend, nn_factx
+                 DO jj = njstr, njend, nn_facty
+                    ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                    ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                    ijje = mje_crs(ij)
+                    ijie = mie_crs(ii)
+                    !                  
+                    zsfcrs      =  zsurf3d(ji,ijje,jk) + zsurf3d(ji+1,ijje,jk) + zsurf3d(ji+2,ijje,jk)
+                    !
+                    zsfcrs_msk  =  zsurf3d(ji  ,ijje,jk) * p_mask(ji  ,ijje,jk) &
+                      &          + zsurf3d(ji+1,ijje,jk) * p_mask(ji+1,ijje,jk) &
+                      &          + zsurf3d(ji+2,ijje,jk) * p_mask(ji+2,ijje,jk) 
+                    !
+                    p_surf_crs    (ii,ij,jk) = zsfcrs
+                    p_surf_crs_msk(ii,ij,jk) = zsfcrs_msk
+                    !
+                  ENDDO      
+              ENDDO
+           ENDDO   
+
+           CALL wrk_dealloc( jpi, jpj, jpk, zsurf3d )
             
-       CASE ('U')
-       
-          DO jk = 1 , jpk
-                                             ! ji = 1 et jpi_crs definit par cyclique est-ouest et pivot T
-             DO ji = 2, nlei_crs
-                ijie = mie_crs(ji)
-                ijis = mis_crs(ji)
-                DO jj = njstart, njend 
-                   ijje = mje_crs(jj)  
-                   ijjs = mjs_crs(jj)
-                   DO jii = ijis, ijie
-                      DO jjj = ijjs, ijje   
-                         zsfc =  p_e3(jii,jjj,jk) * p_e2(jii,jjj)  
-                         p_surf_crs(ji,jj,jk)     = p_surf_crs(ji,jj,jk) + zsfc
-                         p_surf_crs_msk(ji,jj,jk) = p_surf_crs_msk(ji,jj,jk) + zsfc * p_mask(jii,jjj,jk)               
-                      ENDDO
-                   ENDDO
-                  IF( njstart == 1 ) p_surf_crs(ji,jj,jk) = p_surf_crs(ji,jj,jk) * nn_facty
-               ENDDO
-            ENDDO
-         ENDDO
-       
-      CASE ('V')
-          
-         DO jk = 1 , ijpk
-                                                                   ! ji = 1 et jpi_crs definit par cyclique est-ouest et pivot T
-            DO ji = 2, nlei_crs
-               ijie = mie_crs(ji)
-               ijis = mis_crs(ji)
-               DO jj = njstart, njend                  ! jj = jpj_crs definit par pivot T 
-                  ijje = mje_crs(jj)   
-                  ijjs = mjs_crs(jj)  
-                  DO jii = ijis, ijie
-                     DO jjj = ijjs, ijje
-                        zsfc = p_e3(jii,jjj,jk) * p_e1(jii,jjj) 
-                        p_surf_crs(ji,jj,jk)     = p_surf_crs(ji,jj,jk) + zsfc
-                        p_surf_crs_msk(ji,jj,jk) = p_surf_crs_msk(ji,jj,jk) + zsfc * p_mask(jii,jjj,jk)   
-                     ENDDO
-                  ENDDO
-               ENDDO
-            ENDDO
-         ENDDO
+         CASE( 'U' )
+         
+           CALL wrk_alloc( jpi, jpj, jpk, zsurf3d )
+           DO jk = 1, jpk
+              zsurf3d(:,:,jk) =  p_e2(:,:) * p_e3(:,:,jk)
+           ENDDO
+         
+           DO jk = 1, jpk
+              DO ji = nistr, niend, nn_factx
+                 DO jj = njstr, njend, nn_facty
+                    ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                    ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                    ijje = mje_crs(ij)
+                    ijie = mie_crs(ii)
+                    !                  
+                    zsfcrs      =  zsurf3d(ijie,jj,jk) + zsurf3d(ijie,jj+1,jk) + zsurf3d(ijie,jj+2,jk)
+                    !
+                    zsfcrs_msk  =  zsurf3d(ijie  ,jj,jk) * p_mask(ijie,jj  ,jk) &
+                      &          + zsurf3d(ijie,jj+1,jk) * p_mask(ijie,jj+1,jk) &
+                      &          + zsurf3d(ijie,jj+2,jk) * p_mask(ijie,jj+2,jk) 
+                    !
+                    p_surf_crs    (ii,ij,jk) = zsfcrs
+                    p_surf_crs_msk(ii,ij,jk) = zsfcrs_msk
+                    !
+                  ENDDO      
+              ENDDO
+           ENDDO  
+ 
+           CALL wrk_dealloc( jpi, jpj, jpk, zsurf3d )
+
       END SELECT
- 
-      
-      CALL crs_lbc_lnk( p_surf_crs    (:,:,:), cd_type, 1.0, pval=1.0 )
-      CALL crs_lbc_lnk( p_surf_crs_msk(:,:,:), cd_type, 1.0, pval=1.0 )
+      
+      CALL crs_lbc_lnk( p_surf_crs    , cd_type, 1.0, pval=1.0 )
+      CALL crs_lbc_lnk( p_surf_crs_msk, cd_type, 1.0, pval=1.0 )
 
 
@@ -1155,8 +1591,6 @@
          nlej_crs   = jpj_crs
          
-        !!! Calculs suivant une découpage en j
-     
+        ! Calculs suivant une découpage en j
         DO jn = 1, jpnij, jpni
-         
            IF( jn < (jpnij-jpni + 1)) THEN
               nlejt_crs(jn) = AINT( REAL( ( jpjglo - (njmppt(jn     ) - 1) ) / nn_facty, wp ) ) &
@@ -1167,5 +1601,4 @@
            
            SELECT CASE( ibonjt(jn) )
-           
               CASE ( -1 )
                 IF( MOD( jpjglo - njmppt(jn), nn_facty) > 0 )    nlejt_crs(jn) = nlejt_crs(jn) + 1
@@ -1198,11 +1631,8 @@
            ENDDO
         ENDDO 
-                 WRITE(numout,*) ' njmppt_crs', njmppt_crs
-         nlej_crs  = nlejt_crs(nproc + 1) 
-         nlcj_crs  = nlcjt_crs(nproc + 1)
-         nldj_crs  = nldjt_crs(nproc + 1)
-         njmpp_crs = njmppt_crs(nproc + 1)
-
-
+        nlej_crs  = nlejt_crs(nproc + 1) 
+        nlcj_crs  = nlcjt_crs(nproc + 1)
+        nldj_crs  = nldjt_crs(nproc + 1)
+        njmpp_crs = njmppt_crs(nproc + 1)
 
          !!!! Calcul suivant un decoupage en i
@@ -1218,5 +1648,4 @@
            
                  CASE ( -1 )
-                 
                    nleit_crs(jn) = nleit_crs(jn) + jpreci           
                    nlcit_crs(jn) = nleit_crs(jn) + jpreci
@@ -1224,5 +1653,4 @@
               
                  CASE ( 0 )
-              
                    nleit_crs(jn) = nleit_crs(jn) + jpreci
                    nlcit_crs(jn) = nleit_crs(jn) + jpreci
@@ -1230,5 +1658,4 @@
                 
                  CASE ( 1, 2 )
-                 
                    IF( MOD( jpiglo - nimppt(jn), nn_factx) > 0 )    nleit_crs(jn) = nleit_crs(jn) + 1
                    nleit_crs(jn) = nleit_crs(jn) + jpreci
@@ -1254,7 +1681,5 @@
          nimpp_crs = nimppt_crs(nproc + 1)
 
-
-         
-         !!! rajouter la condition stop
+         ! rajouter la condition stop
          IF( jpizoom /= 1 .OR. jpjzoom /= 1)    STOP 
          DO ji = 1, jpi_crs
@@ -1265,6 +1690,4 @@
          ENDDO
 
-         
-          
       ENDIF
       
@@ -1434,59 +1857,42 @@
       END SELECT
 
-
-        ! Pad the boundaries, do not know if it is necessary
-         mis2_crs(1) = 1            ; mis2_crs(jpiglo_crs) = mie2_crs(jpiglo_crs - 1) + 1   
-         mie2_crs(1) = nn_factx     ; mie2_crs(jpiglo_crs) = jpiglo                         
-         mje2_crs(1) = mjs2_crs(2)-1; mje2_crs(jpjglo_crs) = jpjglo
-         mjs2_crs(1) = 1            ; mjs2_crs(jpjglo_crs) = mje2_crs(jpjglo_crs) - nn_facty + 1 
- 
-
-         
+     ! Pad the boundaries, do not know if it is necessary
+      mis2_crs(1) = 1             ; mis2_crs(jpiglo_crs) = mie2_crs(jpiglo_crs - 1) + 1   
+      mie2_crs(1) = nn_factx      ; mie2_crs(jpiglo_crs) = jpiglo                         
+      mje2_crs(1) = mjs2_crs(2)-1 ; mje2_crs(jpjglo_crs) = jpjglo
+      mjs2_crs(1) = 1             ; mjs2_crs(jpjglo_crs) = mje2_crs(jpjglo_crs) - nn_facty + 1 
  
       IF( .NOT. lk_mpp ) THEN     
-         njstart = 1     ;    njend =  jpj_crsm1
-         mis_crs(:) = mis2_crs(:) 
-         mie_crs(:) = mie2_crs(:)
-         mjs_crs(:) = mjs2_crs(:) 
-         mje_crs(:) = mje2_crs(:)
+        mis_crs(:) = mis2_crs(:) 
+        mie_crs(:) = mie2_crs(:)
+        mjs_crs(:) = mjs2_crs(:) 
+        mje_crs(:) = mje2_crs(:) 
       ELSE
-         !
-         IF( nldj==1 )  THEN  ;   njstart = 1
-         ELSE                 ;   njstart = 2
-         ENDIF
-         !
-         IF(nlcj == nlej) THEN
-            njend = nlej_crs - 1
-         ELSE
-            njend = nlej_crs
-         ENDIF
-         
-         DO jj = 1, nlej_crs
-            mjs_crs(jj) = mjs2_crs(mjg_crs(jj)) - njmpp + 1
-            mje_crs(jj) = mje2_crs(mjg_crs(jj)) - njmpp + 1
-         ENDDO
-         DO ji = 1, nlei_crs
-            mis_crs(ji) = mis2_crs(mig_crs(ji)) - nimpp + 1
-            mie_crs(ji) = mie2_crs(mig_crs(ji)) - nimpp + 1
-         ENDDO
-
-         !
+        DO jj = 1, nlej_crs
+           mjs_crs(jj) = mjs2_crs(mjg_crs(jj)) - njmpp + 1
+           mje_crs(jj) = mje2_crs(mjg_crs(jj)) - njmpp + 1
+        ENDDO
+        DO ji = 1, nlei_crs
+           mis_crs(ji) = mis2_crs(mig_crs(ji)) - nimpp + 1
+           mie_crs(ji) = mie2_crs(mig_crs(ji)) - nimpp + 1
+        ENDDO
       ENDIF
-         WRITE(numout,*) 'crs_init. coarse grid bounds on parent grid'
-         WRITE(numout,*) 'mjg_crs='  , mjg_crs
-         WRITE(numout,*) 'mig_crs='  , mig_crs
-         WRITE(numout,*) 'nimpp_crs=', nimpp_crs
-         WRITE(numout,*) 'njmpp_crs=', njmpp_crs
-         WRITE(numout,*) 'njend='    , njend
-         WRITE(numout,*) 'mis_crs='  , mis_crs
-         WRITE(numout,*) 'mie_crs='  , mie_crs
-         WRITE(numout,*) 'mjs_crs='  , mjs_crs
-         WRITE(numout,*) 'mje_crs='  , mje_crs
-   
-   
+      njstr = mjs_crs(2)  ;   njend = mjs_crs(nlcj_crs - 1)
+      nistr = mis_crs(2)  ;   niend = mis_crs(nlci_crs - 1)
+      WRITE(numout,*) 'crs_init. coarse grid bounds on parent grid'
+      WRITE(numout,*) 'mjg_crs='  , mjg_crs
+      WRITE(numout,*) 'mig_crs='  , mig_crs
+      WRITE(numout,*) 'nimpp_crs=', nimpp_crs
+      WRITE(numout,*) 'njmpp_crs=', njmpp_crs
+      WRITE(numout,*) 'njend='    , njend
+      WRITE(numout,*) 'mis_crs='  , mis_crs
+      WRITE(numout,*) 'mie_crs='  , mie_crs
+      WRITE(numout,*) 'mjs_crs='  , mjs_crs
+      WRITE(numout,*) 'mje_crs='  , mje_crs
+      !
    END SUBROUTINE crs_dom_def
    
    SUBROUTINE crs_dom_bat
-    !!----------------------------------------------------------------
+      !!----------------------------------------------------------------
       !!               *** SUBROUTINE crs_dom_bat ***
       !! ** Purpose :  coarsenig bathy
@@ -1494,10 +1900,9 @@
       !! 
       !!  local variables
-
+      INTEGER  :: ji,jj,jk      ! dummy indices
+      REAL(wp), DIMENSION(:,:)  , POINTER :: zmbk
+      !!----------------------------------------------------------------
    
-   INTEGER  :: ji,jj,jk      ! dummy indices
-   REAL(wp), DIMENSION(:,:)  , POINTER :: zmbk
-   
-   CALL wrk_alloc( jpi_crs, jpj_crs, zmbk )
+      CALL wrk_alloc( jpi_crs, jpj_crs, zmbk )
    
       mbathy_crs(:,:) = jpkm1
@@ -1538,8 +1943,5 @@
       END DO
 
-      WRITE(numout,*) 'crsini. Set mbku, mkbv'
-
       ! convert into REAL to use lbc_lnk ; impose a min value of 1 as a zero can be set in lbclnk
-  
       zmbk(:,:) = 1.e0;    
       zmbk(:,:) = REAL( mbku_crs(:,:), wp )   ;   CALL crs_lbc_lnk(zmbk,'U',1.0) ; mbku_crs  (:,:) = MAX( INT( zmbk(:,:) ), 1 ) 
@@ -1547,6 +1949,5 @@
       !
       CALL wrk_dealloc( jpi_crs, jpj_crs, zmbk )
-      WRITE(numout,*) 'crs_init   = finished section 3d.1 jpi=', jpi, 'jpj=',jpj, ' jpk=', jpk
-
+      !
    END SUBROUTINE crs_dom_bat
 
Index: branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdomwri.F90
===================================================================
--- branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdomwri.F90	(revision 3864)
+++ branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdomwri.F90	(revision 3895)
@@ -21,4 +21,5 @@
    USE lib_mpp         ! MPP library
 !   USE wrk_nemo        ! Memory allocation
+   USE iom_def
    USE iom
    USE crs         ! coarse grid domain
@@ -295,12 +296,12 @@
       SELECT CASE ( MOD(nn_msh_crs, 3) )
       CASE ( 1 )                
-         CALL iom_close( inum0 )
+         CALL crs_iom_close( inum0 )
       CASE ( 2 )
-         CALL iom_close( inum1 )
-         CALL iom_close( inum2 )
+         CALL crs_iom_close( inum1 )
+         CALL crs_iom_close( inum2 )
       CASE ( 0 )
-         CALL iom_close( inum2 )
-         CALL iom_close( inum3 )
-         CALL iom_close( inum4 )
+         CALL crs_iom_close( inum2 )
+         CALL crs_iom_close( inum3 )
+         CALL crs_iom_close( inum4 )
       END SELECT
       !
Index: branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90
===================================================================
--- branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90	(revision 3864)
+++ branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90	(revision 3895)
@@ -15,5 +15,4 @@
    USE in_out_manager
    USE par_kind, ONLY: wp
-   USE crs
    USE crsdom
    USE crsdomwri
@@ -208,16 +207,15 @@
 
      !    3.d.3   Vertical depth (meters)
-
-     CALL crsfun( p_e1e2t=e1e2t, cd_type='T', cd_op='MAX', p_cmask=tmask_crs, p_ptmask=tmask, &
-          &       p_pfield3d_1=gdept, p_cfield3d=gdept_crs ) 
-     CALL crsfun( p_e1e2t=e1e2t, cd_type='W', cd_op='MAX', p_cmask=tmask_crs, p_ptmask=tmask, &
-          &       p_pfield3d_1=gdepw, p_cfield3d=gdepw_crs )
+     CALL crs_dom_ope( gdept, 'MAX', 'T', tmask, gdept_crs, p_e3=zfse3t ) 
+     CALL crs_dom_ope( gdepw, 'MAX', 'W', tmask, gdepw_crs, p_e3=zfse3w )
+
 
      !    3.d.4   Surfaces 
-      
-     CALL crs_dom_sfc( e1t, e2t, zfse3w, 'W', tmask, e1e2w, e1e2w_msk )
-     CALL crs_dom_sfc( e1u, e2u, zfse3u, 'U', umask, e2e3u, e2e3u_msk )
-     CALL crs_dom_sfc( e1v, e2v, zfse3v, 'V', vmask, e1e3v, e1e3v_msk )
+     CALL crs_dom_sfc( tmask, 'T', e1e2w, e1e2w_msk, p_e1=e1t, p_e2=e2t )
+     CALL crs_dom_sfc( umask, 'U', e2e3u, e2e3u_msk, p_e2=e2u, p_e3=zfse3u )
+     CALL crs_dom_sfc( vmask, 'V', e1e3v, e1e3v_msk, p_e1=e1v, p_e3=zfse3v )
    
+     facsurfu(:,:,:) = umask_crs(:,:,:) * e2e3u_msk(:,:,:) / e2e3u(:,:,:)
+     facsurfv(:,:,:) = vmask_crs(:,:,:) * e1e3v_msk(:,:,:) / e1e3v(:,:,:)
 
      !---------------------------------------------------------
@@ -227,17 +225,13 @@
 
 !!     ! jes. May not need ocean_volume_crs_t, ocean_volume_crs_w as calculated already in trc_init as cvol
-      CALL crsfun_wgt( cd_type='T', cd_op='VOL', p_pmask=tmask, p_e1=e1t, p_e2=e2t, p_fse3=zfse3t, &
-         &             p_cfield3d_1=ocean_volume_crs_t, p_cfield3d_2=facvol_t )
-      
-      r1_bt_crs(:,:,:) = 0._wp 
-      bt_crs(:,:,:) = ocean_volume_crs_t(:,:,:)* facvol_t(:,:,:)
-      WHERE( bt_crs /= 0._wp ) r1_bt_crs(:,:,:) = 1._wp/bt_crs(:,:,:)
-
-      CALL crsfun_wgt( cd_type='W', cd_op='VOL', p_pmask=tmask, p_e1=e1t, p_e2=e2t, p_fse3=zfse3w, &
-         &             p_cfield3d_1=ocean_volume_crs_w, p_cfield3d_2=facvol_w )
-
-     ! 4.c. T volume weights
-      CALL crsfun_wgt( cd_type='T', cd_op='WGT', p_pmask=tmask, p_e1=e1t, p_e2=e2t, p_fse3=zfse3t, p_cfield3d_1=crs_volt_wgt )  
-
+     CALL crs_dom_facvol( tmask, 'T', e1t, e2t, zfse3t, ocean_volume_crs_t, facvol_t )
+     !
+     bt_crs(:,:,:) = ocean_volume_crs_t(:,:,:) * facvol_t(:,:,:)
+     !
+     r1_bt_crs(:,:,:) = 0._wp 
+     WHERE( bt_crs /= 0._wp ) r1_bt_crs(:,:,:) = 1._wp / bt_crs(:,:,:)
+
+     CALL crs_dom_facvol( tmask, 'W', e1t, e2t, zfse3w, ocean_volume_crs_w, facvol_w )
+     !
      !---------------------------------------------------------
      ! 5.  Write out coarse meshmask  (see OPA_SRC/DOM/domwri.F90 for ideas later)
